<?php
/**
 * @author  wassim jied January 2018
 * @email   jiwassim@gmail.com 
 * @url     coderspirit.blogspot.com
 * @license GNU/GPL
*/

defined('_JEXEC') or die('Restricted Access');

require_once dirname(__FILE__).DS.'..'.DS.'models'.DS.'JqckCaptchaModel.php';

class JqckCaptchaService {
	
	private $captchaModel;
	
	
	/**
	* Constructor
	*/
	function __construct() {	
		$this->captchaModel = new JqckCaptchaModel();
	}
	
	/**
	* Refresh jqckCaptcha
	* @param no params
	* @return void
	*/
	 function refreshCaptcha()
	{
		if(!isset($_GET['sid']))
			die('invalid request');
		
		$session_id = JRequest::getVar('sid');
		$captcha = $this->captchaModel->getCaptchaBySID($session_id);				
		if($captcha)
		{
			/*
			* Avoid ie 9 ajax failure (since 1.2.3.2)
			*/
			header( 'Cache-Control: no-store, no-cache, must-revalidate' );
			header( 'Pragma: no-cache' );
			// -->	
			$this->prepareCaptcha($session_id);						
		}					
		else
			die('expired');	
	}
	

	/**
	* Manages epired sessions
	*/
	function manageExpiredSessions(){
			$this->captchaModel->deleteCaptchaNotInSession();
	}
	/**
	* Check if captcha is correct
	* @param $sid session ID
	* @param $val the value entered by the user
	* @return boolean true if captcha is correct false in other ways
	**/
	function checkJqckCaptcha($sid,$val){
		   $captcha = $this->captchaModel->getCaptchaBySID($sid);
		   if(count($captcha))
			   return $captcha[0] == $val;
		   return false;
	}
	/**
	* Generates a new capcha code and updates database<br/>
	* @param the SID
	* @param boolean mustExit if truen no image will be sent, only data will be saved
	*/

	public function prepareCaptcha($sid = null,$mustExit=false)
	{
			if($sid == null)
			{
					$session = JFactory::getSession();	
					$sid = $session->getId();
			}
		
			/*
			*
			* this code is based on captcha code by Simon Jarvis 
			* http://www.white-hat-web-design.co.uk/articles/php-captcha.php
			*
			* This program is free software; you can redistribute it and/or 
			* modify it under the terms of the GNU General Public License 
			* as published by the Free Software Foundation
			*
			* This program is distributed in the hope that it will be useful, 
			* but WITHOUT ANY WARRANTY; without even the implied warranty of 
			* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
			* GNU General Public License for more details: 
			* http://www.gnu.org/licenses/gpl.html
			*/
			$image_width = 120;			
			$image_height = 40;
			$possible_letters = '23456789bcdfghjkmnpqrstvwxyz';
			$random_dots = 20;
			$random_lines = 20;
			$captcha_text_color="0x142864";
			$captcha_noice_color = "0x142864";
			$characters_on_image = 6;
			$font = dirname(__FILE__).'/monofont.ttf';
			
			$characters_on_image = 6;

			//The characters that can be used in the CAPTCHA code.
			//avoid confusing characters (l 1 and i for example)
			$possible_letters = '23456789bcdfghjkmnpqrstvwxyz';
			$code = '';


			$i = 0;
			while ($i < $characters_on_image) { 
			$code .= substr($possible_letters, mt_rand(0, strlen($possible_letters)-1), 1);
			$i++;
			}
			$this->captchaModel->insertOrUpdateCaptcha($sid,$code);	
			if($mustExit)			
					return;
			//$font_size = $image_height * 0.75;
			$font_size = 30;
			$image = @imagecreate($image_width, $image_height);


			/* setting the background, text and noise colours here */
			$background_color = imagecolorallocate($image, 255, 255, 255);

			$arr_text_color = $this->hexrgb($captcha_text_color);
			$text_color = imagecolorallocate($image, $arr_text_color['red'], 
					$arr_text_color['green'], $arr_text_color['blue']);

			$arr_noice_color = $this->hexrgb($captcha_noice_color);
			$image_noise_color = imagecolorallocate($image, $arr_noice_color['red'], 
					$arr_noice_color['green'], $arr_noice_color['blue']);


			/* generating the dots randomly in background */
			for( $i=0; $i<$random_dots; $i++ ) 
			{
				imagefilledellipse($image, mt_rand(0,$image_width),
			    mt_rand(0,$image_height), 2, 3, $image_noise_color);  
			}


			/* generating lines randomly in background of image */
			for( $i=0; $i<$random_lines; $i++ ) {
			imageline($image, mt_rand(0,$image_width), mt_rand(0,$image_height),
			 mt_rand(0,$image_width), mt_rand(0,$image_height), $image_noise_color);
			}


			/* create a text box and add 6 letters code in it */
			$textbox = imagettfbbox($font_size, 0, $font, $code); 
			$x = ($image_width - $textbox[4])/2;
			$y = ($image_height - $textbox[5])/2;			
			imagettftext($image, $font_size,  mt_rand(-2,2), $x, $y, $text_color, $font , $code);
			
			
			/*Added by Wassim JIED */
			$tmpFileName = JPATH_COMPONENT.DS.'controllers'.DS.'jqc'.$code;			
				
			//$tmp = tmpfile();
			imagejpeg($image,$tmpFileName,25);//showing the image	
			
			/*Start modified code*/
			$tmp =fopen($tmpFileName,"r");
			$size = filesize($tmpFileName);
			$toTransform = fread($tmp, $size);
		    echo("data:image/jpeg;base64,".base64_encode($toTransform));
			fclose($tmp);			
			unlink($tmpFileName);
            /*End code*/
			imagedestroy($image);//destroying the image instance
			exit();	
			}
			
			private function hexrgb ($hexstr)
			{
			  $int = hexdec($hexstr);

			  return array("red" => 0xFF & ($int >> 0x10),
						   "green" => 0xFF & ($int >> 0x8),
						   "blue" => 0xFF & $int);
			}
			
		/*End captcha code by Simon Jarvis -----*/
		/**
		* Return HTML code that display the captcha
		* Note since there is only one captcha by form, the ID jqckcaptchaimg will be captcha's image  ID
		* @param $name HTML input name
		* @param $id HTML input ID
		* @param ID input of verification in form
		* @return HTML the HTML
		*/
		public function getFrontEndJQckCaptcha($namePrefix,$idPrefix,$idInput){
				$session = JFactory::getSession();	
				$sid = $session->getId();				
				$html ='<img style="float:left;" id="jqckcaptchaimg" width="120px" height="40px"><br/>';
				$html.='<div id="jqckCaptchaContainer" style="clear:both">';
				$html.='<a href="javascript:void(refreshJQCaptcha());">'.JText::_( 'REFRESH' ).'</a><br/>';
				$html.='</div>';	
				$html.='<div class="jqck-fo-item-label-1-'.$idInput.'" id="jqck-fo-item-label-1-'.$idInput.'">'.JText:: _ ('JQCK_ENTER_CAPTCHA').'</div>';				
				$html.='<div id="jqck-fo-item-content'.$idInput.'" style="clear:both">';				
				$html.='<input type="text" name="'.$namePrefix.$idInput.'" id="'.$idPrefix.$idInput.'" ></input>';	
				$html.='</div>';
				$this->prepareCaptcha(null,true);
				return $html.$this->enqueueFrontEndJS($sid);
		}
		/**
		* Enqueue need JS to perform captcha refresh when needed and at the begin
		* @param $sid Session Id 
		* @return HTML
		*/
		private function enqueueFrontEndJS($sid){
			$html='
					<script language="javascript">
					function refreshJQCaptcha(){
					var url = "'.JURI::base() .'index.php?option=com_jquickcontact&task=refresh&sid='.$sid.'";
				   
					if (window.XMLHttpRequest) { 
						xhr = new XMLHttpRequest();
					}
					else if (window.ActiveXObject) 
					{
						xhr = new ActiveXObject("Microsoft.XMLHTTP");
					}
					xhr.onreadystatechange = function() { alertAjax(xhr); };
					xhr.open("GET",url, true);
					xhr.send(null);
					}
				function alertAjax(xhr)
				{    if(xhr.readyState == 4)
					{
						if(xhr.status == 200)
						{		
							var img64 = xhr.responseText;
							console.log(img64);							
							if(img64.indexOf("expired")!= -1)
								location.href="'.JURI::current().'";
							else	
								document.images.jqckcaptchaimg.src = img64;
							  
						}
						else
							alert("error retrieving data"+xhr.status);            
					}
				}
				refreshJQCaptcha();
			</script>';
			return $html;
		}
		/**
		* Google recaptcha typical implementation
		* @param none
		* @return HTML
		*/
		public function getFrontEndJQckReCaptcha($publicKey){
			$html='<script src="https://www.google.com/recaptcha/api.js"></script>';
			$html.='<div class="control-group">';
			$html.='<div class="g-recaptcha" data-sitekey="'.$publicKey.'"></div>';
			$html.='</div>';			
			return $html;
		}
}