<?php
/**
 * @author wassim jied
 * @email jiwassim@gmail.com
 * A service that generates the html code of entities used in by the component
 * Last modification November 1st 2017
 */
defined('_JEXEC') or die('Restricted access');
class JqckHtmlService{
    
    /**
     * Return the html of a label
     * @param int $formNo the id of the form container of the field used to set the html class and id of the field
     * @param int $itemNo the id of the item in its form
     * @param string $label the label to set 
     */
    public static function outFrontEndLabel($formNo,$itemNo,$label){
             $html='<div class="jqck-fo-item-label-'.$formNo.'" id="jqck-fo-item-label-'.$formNo.'-'.$itemNo.'">';
             $html.=$label;
             $html.='</div>';		   
             return $html;
    }
    
    /**
     * Return the html of a field in the front end
     * @param int $formNo
     * @param int $itemNo
     * @param string $fieldKind HTML5 type of the field
     * @param string $defaultValue value of the input
     * @return html
     */
    public static function outFrontEndTextField($formNo,$itemNo,$fieldKind,$defaultValue){
        $html = JqckHtmlService::outFrontEndFieldBegin($formNo, $itemNo);        
        $html.='<input type="'.strtolower($fieldKind).'" name="jqck_item_'.$formNo.'_'.$itemNo.'" id="jqck-item-'.$formNo.'-'.$itemNo.'"';
        if($defaultValue != ""){
            $html.='value="'.$defaultValue.'"';
       }
        $html.=' />';
        $html.= JqckHtmlService::outFrontEndFieldEnd();   
        return $html;
        
    }
    /**
     * Return the html for a raw html ...
     * @param html $html
     * @return html
     */
    public static function outFrontEndRawHtml($html){
        return $html;
    }
    /**
     * Returns a textarea content
     * @param int $formNo
     * @param int $itemNo
     * @param string $defaultValue
     * @return html
     */
    public static function outFrontEndTextAreaContent($formNo,$itemNo,$defaultValue){
        $html = JqckHtmlService::outFrontEndFieldBegin($formNo, $itemNo);        
        $html.='<textarea name="jqck_item_'.$formNo.'_'.$itemNo.'" id="jqck-item-'.$formNo.'-'.$itemNo.'" rows="8" cols="60">';
        if($defaultValue != ""){
            $html.='value="'.$defaultValue.'"';
        }
        $html.='</textarea>';	
        $html.= JqckHtmlService::outFrontEndFieldEnd();   
        return $html;        
    }
    /**
     * Returns a combobox
     * @param type $formNo
     * @param type $itemNo
     * @param type $content  (data to be ddisplay one value per line
     * @return string
     */
    public static function outFrontComboHtml($formNo,$itemNo,$content){        
        $values = preg_split('/\r\n|[\r\n]/', $content);
        $html = JqckHtmlService::outFrontEndFieldBegin($formNo, $itemNo);  
        $html.='<select name="jqck_item_'.$formNo.'_'.$itemNo.'" id="jqck-item-'.$formNo.'-'.$itemNo.'">';
        $counter = 0;
        foreach ($values as $value){
            $html.="<option value='".$counter."'>";
            $html.=$value;
            $html.="</option>";
            $counter++;
         }
        
        $html.="</select>";
        return $html;
    }
    
    /**
     * returns a html of a combo
     * @param type $formNo
     * @param type $itemNo
     * @param type $content
     * @return string
     */
    public static function outFrontComboHtmlFeatured($formNo,$itemNo,$content){        
    $values = preg_split('/\r\n|[\r\n]/', $content);
    $html = JqckHtmlService::outFrontEndFieldBegin($formNo, $itemNo);  
    $html.='<select name="jqck_item_'.$formNo.'_'.$itemNo.'" id="jqck-item-'.$formNo.'-'.$itemNo.'">';
    $counter = 0;
    while ($counter < count($values)){

        $html.="<option value='".$values[$counter]."'>";
        $counter++;
        if($counter<count($values)){
            $html.=$values[$counter];
        }else{
            $html.='XXX';
        }
        $html.="</option>";
        $counter++;
     }

    $html.="</select>";
    return $html;
}
            
    /**
     * Html for the begin of a new field display
     * @param type $formNo
     * @param type $itemNo
     * @return string
     */
    private static function outFrontEndFieldBegin($formNo,$itemNo){
        return '<div class="jqck-fo-item-content-'.$formNo.'" id="jqck-fo-item-content-'.$formNo.'-'.$itemNo.'">';        
    }
    
    /**
     * Html closing or indicating the end of a field
     * @return string
     */
    private static function outFrontEndFieldEnd(){
        return '</div>';	
    }    
}