<?php
/**
 * JQuickContact component (Front controller)
 * @author  wassim jied 
 * @email   jiwassim@gmail.com 
 * @uri     coderspirit.blogspot.com
 * @license    GNU/GPL
 * @last update October 2017
*/
 
// No direct access 
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controller');
 
/**
 * JQuickContact Component Front controller
 */
class JQuickContactController extends JControllerLegacy
{

	private $errors;	
	private $sid;
	private $engine;
	private $captchaService;
	
	function __construct()
	{
		$session = JFactory::getSession();	
		$this->sid = $session->getId();			
		$this->engine =  new JqckXmlEngine();		
		$this->captchaService = new JqckCaptchaService();
		
		$this->errors = array();				
	}
    /**
     * Method to display the view
	 * Inherited
     */
    function display($cachable = false, $urlparams = null)
    {		
		$view = new JQuickContactViewContact();
		$html = $this->engine->getFrontEndFieldsView($this->getFormNo(),count($this->errors)!= 0);
		$view->assignRef('html', $html);
		$view->assignRef('errors', $this->errors);
		$view->assignRef('sid', $this->sid);		
		
		// get a menu item based on Itemid or currently active menu item
		$app	= JFactory::getApplication();
		$menu	= $app->getMenu();	

		if (empty($query['Itemid'])) {
			$menuItem = $menu->getActive();
		} else {
			$menuItem = $menu->getItem($query['Itemid']);
		}		
		$view->assignRef('Itemid', $menuItem->id);			
		
		$view->display();		
    }
	
	/**
	* Method to execute requested action
	*/
	function execute($task=null)
	{
		
		$this->engine->newInvokationRoutine();
		switch($task)
		{
		        case 'expired':  $this->engine->manageSessionExpiration();
			                 break;
			case 'refresh':  $this->refreshCaptcha();
							 break;
			case 'do'     :  $this->processForm();
		    default	      :  $this->display();
		}
	}
	
	/**
	* Returns the forn number 
	* @param: no params
	*/
	function getFormNo(){
		return 1;
	}
	function processForm(){
			$this->errors = $this->engine->processForm('index.php?option=com_jquickcontact&Itemid='.JRequest::getVar('Itemid',''),$this->sid);
			if (count($this->errors) == 0){
						$link	= 'index.php?option=com_jquickcontact&Itemid=';
						$this->setRedirect($link, JText::_('WELL_DONE'));
			}
				else
					JError::raiseNotice( 500, JText:: _ ('EMAIL_NOT_SENT' ));
	}

	/**
	* Method invoked after ajax call failure (session invalidated?)
	* @since 1.2.2
	*/
	function manageSessionExpiration()
	{
			$link	= 'index.php?option=com_jquickcontact&Itemid=';
		    if(isset($_GET['Itemid']))	
			   $link.=JRequest::getVar('Itemid');
			$msg	= JText::_( 'SESSION_RESETED' );		
			$this->setRedirect($link, $msg);
	}
	/**
	* Call refreshCaptcha method in Captcha Service
	* @params No params
	* @return image of the captcha
	**/
	function refreshCaptcha(){
		return $this->captchaService->refreshCaptcha();
	}
	
	
   /**
	* Method to check new contact contstraints
	*
	*@access private
	*/
	private function checkContents()
	{
		$captcha = $this->model->getCorrectCaptcha();	
		$this->model->senderName = $_POST['name'];
		$this->model->senderMail = $_POST['email'];
		$this->model->_object = $_POST['object'];
		$this->model->content= $_POST['message'];

		$row = $this->config['FIELD0'];				
		$min_sz = $row['MIN_SZ'];
		$max_sz = $row['MAX_SZ'];
		if(strlen($this->model->senderName)<$min_sz)
			$this->errors[] = JText:: _ ('USER_NAME' ).' '.JText::sprintf( 'TOO_SHORT', $min_sz);	
		if(strlen($this->model->senderName)>$max_sz)
			$this->errors[] = JText:: _ ('USER_NAME' ).' '.JText::sprintf( 'TOO_SHORT', $max_sz);			
			jimport('joomla.mail.helper');
		if(!JMailHelper::isEmailAddress ($this->model->senderMail))		
			$this->errors[] = JText:: _ ('INCORRECT_MAIL_FORMAT' );
		
		$row = $this->config['FIELD1'];				
		$min_sz = $row['MIN_SZ'];
		$max_sz = $row['MAX_SZ'];
		if(strlen($this->model->_object)<$min_sz)
			$this->errors[] = JText:: _ ('SUBJECT' ).' '.JText::sprintf( 'TOO_SHORT', $min_sz);	
		if(strlen($this->model->_object)>$max_sz)
			//since 1.2.1 (Correction TOO_SHORT-> TOO_LONG
			$this->errors[] = JText:: _ ('SUBJECT' ).' '.JText::sprintf( 'TOO_LONG', $max_sz); 			
		//die('object = '.$this->model->_object.' '.$min_sz.' '.$max_sz);

		$row = $this->config['FIELD2'];				
		$min_sz = $row['MIN_SZ'];
		$max_sz = $row['MAX_SZ'];
		if(strlen($this->model->content)<$min_sz)
			$this->errors[] = JText:: _ ('CONTENT' ).' '.JText::sprintf( 'TOO_SHORT', $min_sz);	
		if(strlen($this->model->content)>$max_sz)
			//since 1.2.1 (Correction TOO_SHORT-> TOO_LONG
			$this->errors[] = JText:: _ ('CONTENT' ).' '.JText::sprintf( 'TOO_LONG', $max_sz);		
			
		if(htmlspecialchars($_POST['captcha']) != $captcha)
				$this->errors[] = JText:: _ ('CPATCHA_ERROR' );
		if(count($this->errors)>0)	
			return 0;		
		return 1;
	}

	/**
	* To check mail format
	*
	*@access private
	*/
	private function isValidInetAddress($data, $strict = false) 
	{ 
	  $regex = $strict? 
		  '/^([.0-9a-z_-]+)@(([0-9a-z-]+\.)+[0-9a-z]{2,4})$/i' : 
		   '/^([*+!.&#$�\'\\%\/0-9a-z^_`{}=?~:-]+)@(([0-9a-z-]+\.)+[0-9a-z]{2,4})$/i' 
	  ; 
	  if (preg_match($regex, trim($data), $matches)) { 
		return array($matches[1], $matches[2]); 
	  } else { 
		return false; 
	  } 
	}


}
?>